<?php
//ini_set("display_errors",1);
//error_reporting(E_ALL);

defined('_JEXEC') or die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');
/**
 * abstract class for payment/shipment plugins
 *  
 * Virtual Card Services Payment Plugin
 *   
 * @author SoftPill.Eu
 * @link http://www.softpill.eu
 * @copyright Copyright (c) 2014 SoftPill.Eu. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.txt
 * This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * @version 1.0 Nov 2014
 */

if (!class_exists('vmPSPlugin'))
require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');

class plgVmPaymentVirtualCardServicesForVirtuemart extends vmPSPlugin {

	public static $_this = false;

	function __construct(& $subject, $config) {
  if(!empty($_GET['m_1'])){
			$_GET['on']=$_GET['m_4'];
			$_GET['pm']=$_GET['m_5'];
			echo "<script>location.href='index.php?option=".$_GET['option']."&view=".$_GET['view']."&task=".$_GET['task']."&on=".$_GET['on']."&pm=".$_GET['pm']."&vcs_status=".$_GET['p3']."'</script>";		
		}
		parent::__construct($subject, $config);
    
		$this->_loggable = true;
		$this->tableFields = array_keys($this->getTableSQLFields());
		$this->_tablepkey = 'id'; 
		$this->_tableId = 'id'; 
		$varsToPush = array(
    'vcs_terminal_id'           => array('', 'char'),
    'vcs_description_of_goods'       => array('', 'char'),
    'payment_logos'       => array('', 'char'),
    'vcs_currency'           => array('', 'char'),
    'vcs_populate_payer_email'       => array('', 'char'),
    'vcs_sms_send'           => array('', 'char'),
    'vcs_mobile_number'           => array('', 'char'),
    'vcs_sms_message'           => array('', 'char'),
    'vcs_md5_salt'           => array('', 'char'),
    'countries'           => array('', 'char'),
    'min_amount'          => array('', 'int'),
    'max_amount'          => array('', 'int'),
    'cost_per_transaction'=> array('', 'int'),
    'cost_percent_total'  => array('', 'int'),
    'tax_id'              => array(0, 'int'),
    'status_pending'      => array('', 'char'),
    'status_success'      => array('', 'char'),
    'status_canceled'     => array('', 'char'));
		$this->setConfigParameterable($this->_configTableFieldName, $varsToPush);
	}
	public function getVmPluginCreateTableSQL() {
		return $this->createTableSQL('Payment Virtual Card Services Table');
	}
	function getTableSQLFields() {

		$SQLfields = array(
    'id' => 'int(11) UNSIGNED NOT NULL AUTO_INCREMENT',
		'virtuemart_order_id' => 'int(1) UNSIGNED',
		'order_number' => 'char(64)',
		'virtuemart_paymentmethod_id' => 'mediumint(1) UNSIGNED',
		'payment_name' => 'varchar(5000)',
		'payment_order_total' => 'decimal(15,5) NOT NULL',
		'payment_currency' => 'smallint(1)',
    'payment_order_total'     => 'decimal(15,5) NOT NULL DEFAULT \'0.00000\'',
		'cost_per_transaction' => 'decimal(10,2)',
		'cost_percent_total' => 'decimal(10,2)',
		'tax_id' => 'smallint(1)',
    );
		return $SQLfields;
	}
	function setParams($param_array,$comp_name)
  {
    if ( count($param_array) > 0 )
    {
      jimport('joomla.version');
      $jver = new JVersion();
      $jversion=$jver->getShortVersion();
      $joomla_ver=2;
      if(version_compare($jversion,'2.5','<'))
      {
        $joomla_ver=1;
      }
      if($joomla_ver==1)
      {
        $db = JFactory::getDbo();
        $params1=$this->getParams($comp_name);
        foreach ( $param_array as $name => $value )
        {
          $params1[ (string) $name ] = (string) $value;
        }
        $params="";
        foreach ( $params1 as $name => $value )
        {
          $params.=$name."=".$value."\n";
        }
        $db->setQuery('UPDATE #__plugins SET params = ' .
        $db->quote( $params ) .
        ' WHERE element = '.$db->quote($comp_name));
        $db->query();
      }
      else
      {
        $db = JFactory::getDbo();
        $db->setQuery('SELECT params FROM #__extensions WHERE element = '.$db->quote($comp_name));
        $params1 = json_decode( $db->loadResult(), true );
        foreach ( $param_array as $name => $value )
        {
          $params1[ (string) $name ] = (string) $value;
        }
        $params1String = json_encode( $params1 );
        $db->setQuery('UPDATE #__extensions SET params = ' .
        $db->quote( $params1String ) .
        ' WHERE element = '.$db->quote($comp_name));
        $db->query();
      }
    }
  }
  function getParams($comp_name)
  {
    jimport('joomla.version');
    $jver = new JVersion();
    $jversion=$jver->getShortVersion();
    $joomla_ver=2;
    if(version_compare($jversion,'2.5','<'))
    {
      $joomla_ver=1;
    }
    if($joomla_ver==1)
    {
      $params1=array();
      $db = JFactory::getDbo();
      $db->setQuery('SELECT params FROM #__plugins WHERE element = '.$db->quote($comp_name));
      $params=$db->loadResult();
      
      if($params!="")
      {
        $tarr=explode("\n",$params);
      }
      if(count($tarr)>0)
      {
        foreach($tarr as $p)
        {
          if($p!="")
          {
            $pos = strpos($p, "=");
            if ($pos === false) {}
            else
            {
              $key=substr($p,0,$pos);
              $val=substr($p,($pos+1),strlen($p));
              $params1[$key]=$val;
            }
          }
        }
      }
      return $params1;
    }
    else
    {
      $db = JFactory::getDbo();
      $db->setQuery('SELECT params FROM #__extensions WHERE element = '.$db->quote($comp_name));
      $params1 = json_decode( $db->loadResult(), true );
      return $params1;
    }
  }
	function checkLicense($lic)
  {
    $checkurl='http://www.softpill.eu/check_complic.php?comp=virtualcardservicesforvirtuemart&h='.str_ireplace("www.","",$_SERVER['HTTP_HOST']).'&lic='.$lic;
    if (!function_exists('curl_init'))
    {
      $output=@file_get_contents($checkurl);
      if($output==str_ireplace("www.","",$_SERVER['HTTP_HOST']))
      {
        $ok = 1;
      }
    }
    else
    {
      $ch = curl_init();
      curl_setopt($ch, CURLOPT_URL, $checkurl);
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
      $output = curl_exec($ch);
      curl_close($ch);
      if($output==str_ireplace("www.","",$_SERVER['HTTP_HOST']))
      {
        $ok = 1;
      }
    }
  
    
    $application = JFactory::getApplication();
    if(@$ok==1)
    {
      $chk=md5($lic.str_ireplace("www.","",$_SERVER['HTTP_HOST']));
      $this->setParams(array('dchk'=>$chk,'vcslic'=>$lic),'virtualcardservicesforvirtuemart');
      $application->enqueueMessage('Thank You for Activating your Virtual Card Services - Payment Gateway', 'success');
      return 1;
    }
    else
    {
      $this->setParams(array('vcslic'=>'','dchk'=>''),'virtualcardservicesforvirtuemart');
      $application->enqueueMessage('Provided License code is wrong', 'error');
      return 0;
    }
  }
  
	function plgVmConfirmedOrder($cart, $order)
  {
    $params1  = $this->getParams('virtualcardservicesforvirtuemart');
    $dchk=$params1['dchk'];
    $lic=$params1['vcslic'];
    $chk=md5($lic.str_ireplace("www.","",$_SERVER['HTTP_HOST']));
    //print_r($params1);
    if($dchk!=$chk)
    {
      $application = JFactory::getApplication();
      if($lic=="")
      {
        $application->enqueueMessage('Please input your Virtual Card Services - Payment Gateway License Code', 'error');
        $this->setParams(array('vcslic'=>'','dchk'=>''),'virtualcardservicesforvirtuemart');
        return;
      }
      else
      {
        $dchk=@$params1['dchk'];
        if($dchk=='')
        {
          if(!$this->checkLicense($lic))
          {
            return;
          }
        }
        else
        {
          $chk=md5($lic.str_ireplace("www.","",$_SERVER['HTTP_HOST']));
          if($chk!=$dchk)//check
          {
            //$this->setParams(array('vcslic'=>'','dchk'=>''),'virtualcardservicesforvirtuemart');
            $application->enqueueMessage('Provided License code is wrong', 'error');
            return;
          }
        }
      }
    }
    
		if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) {
			return null; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return false;
		}
		$session = JFactory::getSession();
		$this->logInfo('plgVmConfirmedOrder order number: ' . $order['details']['BT']->order_number, 'message');
		if (!class_exists('VirtueMartModelOrders'))
		require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
		if (!class_exists('VirtueMartModelCurrency'))
		require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'currency.php');
		$new_status = '';
		$usrBT = $order['details']['BT'];
		$usrST = isset($order['details']['ST'])?$order['details']['ST']:$order['details']['BT'];
		if (!class_exists('TableVendors'))
		require(JPATH_VM_ADMINISTRATOR . DS . 'table' . DS . 'vendors.php');
		$vendorModel = VmModel::getModel('Vendor');
		$vendorModel->setId(1);
		$vendor = $vendorModel->getVendor();
		$vendorModel->addImages($vendor, 1);
		$this->getPaymentCurrency($method);
		$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
		$db = JFactory::getDBO();
		$db->setQuery($q);
		$currency_code_3 = $db->loadResult();
		$paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
		$totalInPaymentCurrency = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $order['details']['BT']->order_total, false), 2);
		
    if (empty($method->vcs_terminal_id)) {
			vmInfo(JText::_('Virtual Card Services Terminal ID Missing!!!'));
			return false;
		}
    
    $currency_code_arr=array('ZAR','BWP','NAD');
    if(!in_array($currency_code_3,$currency_code_arr))
    {
      $currency_code_3='ZAR';
    }
    if($method->vcs_currency!="" && $method->vcs_currency!=$currency_code_3)
    {
      $currency_code_3=$method->vcs_currency;
    }
    
    $amount=round($order['details']['BT']->order_total,2);
		$post_variables_md5 = Array('p1' => $method->vcs_terminal_id,
			'p2' => $order['details']['BT']->order_number,
			'p3' => $method->vcs_description_of_goods.' '.$order['details']['BT']->order_number,
			'p4' => $amount,
			'p5' => $currency_code_3,
			'p6' => '0',			
			'p7' => '',			
			'p8' => $method->vcs_sms_send == 'Y' ? $method->vcs_mobile_number : '',			
			'p9' => $method->vcs_sms_send == 'Y' ? $method->vcs_sms_message : '',			
			'p10' => JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginUserPaymentCancel&on=' . $order['details']['BT']->order_number . '&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id),			
			'p11' => '',			
			'p13' => '0',			
			'NextOccurDate' => '',				
			'CardHolderEmail' => $order['details']['BT']->email,			
			'm_1' => 'com_virtuemart',			
			'm_2' => 'pluginresponse',			
			'm_3' => 'pluginresponsereceived',			
			'm_4' => $order['details']['BT']->order_number,			
			'm_5' => $order['details']['BT']->virtuemart_paymentmethod_id,			
			'm_6' => '',			
			'm_7' => '',			
			'm_8' => '',			
			'm_9' => '',			
			'm_10' => '');
		$hash_string = @implode('', $post_variables_md5);
		$hash_post = md5($hash_string . $method->vcs_md5_salt);
		/* MD5 HASH Calculation Ends */
		$post_variables = Array('p1' => $method->vcs_terminal_id,
			'p2' => $order['details']['BT']->order_number,
			'p3' => $method->vcs_description_of_goods.' '.$order['details']['BT']->order_number,
			'p4' => $amount,
			'p5' => $currency_code_3,
			'p6' => '0',
			'p7' => '',
			'p8' => $method->vcs_sms_send == 'Y' ? $method->vcs_mobile_number : '',
			'p9' => $method->vcs_sms_send == 'Y' ? $method->vcs_sms_message : '',
			'p10' => JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginUserPaymentCancel&on=' . $order['details']['BT']->order_number . '&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id),			
			'p11' => '',			
			'p12' => 'N',			
			'p13' => '0',			
			'NextOccurDate' => '',			
			'CardHolderEmail' => $order['details']['BT']->email,			
			'm_1' => 'com_virtuemart',			
			'm_2' => 'pluginresponse',			
			'm_3' => 'pluginresponsereceived',			
			'm_4' => $order['details']['BT']->order_number,			
			'm_5' => $order['details']['BT']->virtuemart_paymentmethod_id,			
			'm_6' => '',			
			'm_7' => '',			
			'm_8' => '',			
			'm_9' => '',			
			'm_10' => '',			
			'URLSProvided' => 'Y',			
			'ApprovedUrl' => JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginResponseReceived&on=' . $order['details']['BT']->order_number . '&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id) ,			
			'DeclinedUrl' => JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginResponseReceived&on=' . $order['details']['BT']->order_number . '&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id),			
			'Hash' => $hash_post);
    
    // Prepare data that should be stored in the database
		$dbValues['order_number'] = $order['details']['BT']->order_number;
		$dbValues['payment_name'] = $this->renderPluginName($method, $order);
		$dbValues['virtuemart_paymentmethod_id'] = $order['details']['BT']->virtuemart_paymentmethod_id;
		$dbValues['cost_per_transaction'] = $method->cost_per_transaction;
		$dbValues['cost_percent_total'] = $method->cost_percent_total;
		$dbValues['payment_currency'] = $method->payment_currency;
		$dbValues['payment_order_total'] = $totalInPaymentCurrency;
		$dbValues['tax_id'] = $method->tax_id;
    $this->storePSPluginInternalData($dbValues);
    
    $VCS_button='Click here to Pay';
		$url = $this->_getVcsUrlHttps($method);
		$html = '<html><head><title>Redirection</title></head><body><div style="margin: auto; text-align: center;">';
    $html .= '<form action="' . "https://" . $url . '" method="post" name="vm_vcs_form" >';
    $html.= '<input type="submit"  value="'.$VCS_button.'" />';
		foreach ($post_variables as $name => $value)
    {
      $html.= '<input type="hidden" name="'.$name.'" value="'.htmlspecialchars($value).'" />';
    }
		$html.= '</form></div>';
    $html.= ' <script type="text/javascript">';
    $html.= ' document.vm_vcs_form.submit();';
    $html.= ' </script></body></html>';
		return $this->processConfirmedOrderPaymentResponse(2, $cart, $order, $html, $dbValues['payment_name'], $new_status);
	}
	
	function plgVmOnUserPaymentCancel() {
		$mainframe = JFactory::getApplication();
    $mainframe->enqueueMessage('Your order timed out', 'error');
    $mainframe->redirect('index.php?option=com_virtuemart&view=cart');
    exit;
	}
	
	function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId) {
		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
			return null; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return false;
		}
		$this->getPaymentCurrency($method);
		$paymentCurrencyId = $method->payment_currency;
	}
	
	function plgVmOnPaymentResponseReceived(&$html) {
	
	  $virtuemart_paymentmethod_id = JRequest::getInt('pm', 0);		
		$order_number = JRequest::getVar('on', 0);		
		$vendorId = 0;		
		/* check that the payment method exists */		
		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id)))			
			return null;	
			
		/* check that this payment method is selected */		
		if (!$this->selectedThisElement($method->payment_element))			
			return false;		
			
		/* check that the cart module has been loaded */		
		if (!class_exists('VirtueMartCart'))			
			require(JPATH_VM_SITE . DS . 'helpers' . DS . 'cart.php');		
			
		/* check that the Shop functions module has been loaded */		
		if (!class_exists('shopFunctionsF'))			
			require(JPATH_VM_SITE . DS . 'helpers' . DS . 'shopfunctionsf.php');	
			
		/* check that the order modules has been loaded */		
		if (!class_exists('VirtueMartModelOrders'))			
			require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );		
			
		$vcs_data = JRequest::get('get');		
		//print_r($vcs_data);
		$payment_name = $this->renderPluginName($method);		
		if (!empty($vcs_data))		
		{			
			vmdebug('plgVmOnPaymentResponseReceived', $vcs_data);			
			$order_number = $vcs_data['on'];			
			$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number);			
			$payment_name = $this->renderPluginName($method);			
			if ($virtuemart_order_id)
			{				
				$order['order_status'] = $this->_getPaymentStatus($method, $_GET['vcs_status']);
				$order['comments'] = JText::sprintf('Your payment for order %s has been confirmed by Vcs', $order_number);
				$modelOrder = VmModel::getModel('orders');				
				$orderitems = $modelOrder->getOrder($virtuemart_order_id);
				$nb_history = count($orderitems['history']);				
				if ($orderitems['history'][$nb_history - 1]->order_status_code != $order['order_status'])				
				{
					//$this->_storeVcsInternalData($method, $vcs_data, $virtuemart_order_id);					
					$this->logInfo('plgVmOnPaymentResponseReceived, sentOrderConfirmedEmail ' . $order_number, 'message');
					$order['virtuemart_order_id'] = $virtuemart_order_id;					

          if($order['order_status']==$method->status_success)					
					{
						$order['comments'] = JText::sprintf('Email sent');
						$order['customer_notified']=1;
					}
					else					
					{
						$order['customer_notified']=0;						
					}			
								
					$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, true);				
				}			
			}			
			else			
			{
				vmError('Vcs data received, but no order number');				
				return;			
			}		
		}		
		else		
		{			
			$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number);		
		}		
		
		if (!($paymentTable = $this->getDataByOrderId($virtuemart_order_id) ))			
			return '';		
		$cart = VirtueMartCart::getCart();		
		
		
		if($this->_getPaymentStatus($method, $_GET['vcs_status'])==$method->status_success)//approved
		{
			$html = $this->_getPaymentResponseHtml($paymentTable, $payment_name);		
			$cart->emptyCart();		
		}
		else
		{
			$html = "Your payment was declined. Please try again or contact your card issuer for more information.";
		}
		return true;
	}
	function _getTablepkeyValue($virtuemart_order_id) {
		$db = JFactory::getDBO();
		$q = 'SELECT ' . $this->_tablepkey . ' FROM `' . $this->_tablename . '` '
		. 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
		$db->setQuery($q);

		if (!($pkey = $db->loadResult())) {
			JError::raiseWarning(500, $db->getErrorMsg());
			return '';
		}
		return $pkey;
	}
	
	function _getPaymentStatus($method, $vcs_status) {
		$new_status = $method->status_pending;	
		
		if ($vcs_status == '')			
			$new_status = $method->status_pending;
		if (strstr($vcs_status, 'APPROVED'))
			$new_status = $method->status_success; 
    
		return $new_status;
	}
	
	function _getPayuInternalData($virtuemart_order_id, $order_number='') {
		$db = JFactory::getDBO();
		$q = 'SELECT * FROM `' . $this->_tablename . '` WHERE ';
		if ($order_number) {
			$q .= " `order_number` = '" . $order_number . "'";
		} else {
			$q .= ' `virtuemart_order_id` = ' . $virtuemart_order_id;
		}

		$db->setQuery($q);
		if (!($paymentTable = $db->loadObject())) {
			// JError::raiseWarning(500, $db->getErrorMsg());
			return '';
		}
		return $paymentTable;
	}
	
	function _getPaymentResponseHtml($paymentTable, $payment_name) {
    $db = JFactory::getDBO();
    $query="select order_pass from #__virtuemart_orders where order_number='".$paymentTable->order_number."'";
    $db->setQuery($query);
    $result=$db->loadObject();
    
		$html = '<table>' . "\n";
		$html .= '<tr><td>Payment Name</td><td>'.$payment_name.'</td></tr>';
		$html .= '<tr><td>Order Number</td><td>'.$paymentTable->order_number.'</td></tr>';
		
    if(isset($result->order_pass))
    {
      $html .= '<tr><td>View Order</td><td><a href="'.JURI::base().'index.php?option=com_virtuemart&view=orders&layout=details&order_number='.$paymentTable->order_number.'&order_pass='.$result->order_pass.'">Click here</a></td></tr>';
    }
    
    $html .= '</table>
    ' . "\n";
    if(isset($result->order_pass))
    {
      $html .= '
      <script type="text/javascript">
      alert("Thank You!");
      window.location="'.JURI::base().'index.php?option=com_virtuemart&view=orders&layout=details&order_number='.$paymentTable->order_number.'&order_pass='.$result->order_pass.'";
      </script>
      ';
    }
    	
		return $html;
	}
	
  function sendMailtoAdmin($msg)
  {
    $mailer = JFactory::getMailer();
    $config = JFactory::getConfig();
    $sender = array( 
        $config->getValue( 'config.mailfrom' ),
        $config->getValue( 'config.fromname' ) );
     
    $mailer->setSender($sender);
    
    $mailer->addRecipient($config->getValue( 'config.mailfrom' ));
    $body   = $msg;
    $mailer->setSubject(juri::base().' - Virtual Card Services Warning!');
    $mailer->isHTML(true);
    $body=nl2br($body);
    $mailer->setBody($body);
    $send = $mailer->Send();
  }
	function plgVmOnPaymentNotification() {
    if (!class_exists('VirtueMartModelOrders'))
			require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
		$vcs_data = JRequest::get('get');
		$order_number = $vcs_data['m_4'];		
		$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($vcs_data['m_4']);
		if (!$virtuemart_order_id)			
			return;
		$vendorId = 0;		
		$payment = $this->getDataByOrderId($virtuemart_order_id);
		$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
		if (!$this->selectedThisElement($method->payment_element))			
			return false;
		
		if (!$payment)
		{
			$this->logInfo('getDataByOrderId payment not found: exit ', 'ERROR');			
			return null;
		}
		$this->logInfo('vcs_data ' . implode('   ', $vcs_data), 'message');
		//$this->_storeVcsInternalData($method, $vcs_data, $virtuemart_order_id);
		if (!(empty($error_msg) ))		{
			$new_status = $method->status_canceled;
			$this->logInfo('process IPN ' . $error_msg . ' ' . $new_status, 'ERROR');
		}
		else
		{
			$this->logInfo('process IPN OK', 'message');
		}
		if (empty($_GET['vcs_status']) || ($_GET['vcs_status'] != 'Completed' && $_GET['vcs_status'] != 'Pending'))		{
			//return false;
		}
		$new_status = $this->_getPaymentStatus($method, $_GET['vcs_status']);
		$this->logInfo('plgVmOnPaymentNotification return new_status:' . $new_status, 'message');
		$modelOrder = VmModel::getModel('orders');
		$order = array();
		$order['order_status'] = $new_status;
		$order['customer_notified'] =1;
		$order['comments'] = JText::sprintf('Your payment for order %s has been confirmed by Vcs', $order_number);
		$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, true);
		$this->logInfo('Notification, sentOrderConfirmedEmail ' . $order_number . ' ' . $new_status, 'message');
		$this->emptyCart($return_context);
	}

	function getCosts(VirtueMartCart $cart, $method, $cart_prices) {
		if (preg_match('/%$/', $method->cost_percent_total)) {
			$cost_percent_total = substr($method->cost_percent_total, 0, -1);
		} else {
			$cost_percent_total = $method->cost_percent_total;
		}
		return ($method->cost_per_transaction + ($cart_prices['salesPrice'] * $cost_percent_total * 0.01));
	}
	/**
	 * Check if the payment conditions are fulfilled for this payment method
	 * @author: Valerie Isaksen
	 *
	 * @param $cart_prices: cart prices
	 * @param $payment
	 * @return true: if the conditions are fulfilled, false otherwise
	 *
	 */
	protected function checkConditions($cart, $method, $cart_prices) {
	  
    $this->convert_condition_amount($method);

		$address = (($cart->ST == 0) ? $cart->BT : $cart->ST);

		$amount = $this->getCartAmount($cart_prices);
    $amount_cond = ($amount > 0);
    /*
		$amount_cond = ($amount >= $method->min_amount AND $amount <= $method->max_amount
			OR
			($method->min_amount <= $amount AND ($method->max_amount == 0)));
    */
		$countries = array();
		if (!empty($method->countries)) {
			if (!is_array($method->countries)) {
				$countries[0] = $method->countries;
			} else {
				$countries = $method->countries;
			}
		}
		// probably did not gave his BT:ST address
		if (!is_array($address)) {
			$address = array();
			$address['virtuemart_country_id'] = 0;
		}

		if (!isset($address['virtuemart_country_id'])) {
			$address['virtuemart_country_id'] = 0;
		}
		if (in_array($address['virtuemart_country_id'], $countries) || count($countries) == 0) {
			if ($amount_cond) {
				return TRUE;
			}
		}
    
		return FALSE;
	}
	/**
	 * We must reimplement this triggers for joomla 1.7
	 */
	/**
	 * Create the table for this plugin if it does not yet exist.
	 * This functions checks if the called plugin is active one.
	 * When yes it is calling the standard method to create the tables
	 * @author Valérie Isaksen
	 *
	 */
	function plgVmOnStoreInstallPaymentPluginTable($jplugin_id) {

		return $this->onStoreInstallPluginTable($jplugin_id);
	}
	/**
	 * This event is fired after the payment method has been selected. It can be used to store
	 * additional payment info in the cart.
	 *
	 * @author Max Milbers
	 * @author Valérie isaksen
	 *
	 * @param VirtueMartCart $cart: the actual cart
	 * @return null if the payment was not selected, true if the data is valid, error message if the data is not vlaid
	 *
	 */
	public function plgVmOnSelectCheckPayment(VirtueMartCart $cart) {
		return $this->OnSelectCheck($cart);
	}
	/**
	 * plgVmDisplayListFEPayment
	 * This event is fired to display the pluginmethods in the cart (edit shipment/payment) for exampel
	 *
	 * @param object $cart Cart object
	 * @param integer $selected ID of the method selected
	 * @return boolean True on succes, false on failures, null when this plugin was not selected.
	 * On errors, JError::raiseWarning (or JError::raiseError) must be used to set a message.
	 *
	 * @author Valerie Isaksen
	 * @author Max Milbers
	 */
	public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn) {
		return $this->displayListFE($cart, $selected, $htmlIn);
	}
	/*
	 * plgVmonSelectedCalculatePricePayment
	* Calculate the price (value, tax_id) of the selected method
	* It is called by the calculator
	* This function does NOT to be reimplemented. If not reimplemented, then the default values from this function are taken.
	* @author Valerie Isaksen
	* @cart: VirtueMartCart the current cart
	* @cart_prices: array the new cart prices
	* @return null if the method was not selected, false if the shiiping rate is not valid any more, true otherwise
	*
	*
	*/
	public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name) {
		return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
	}
	/**
	 * plgVmOnCheckAutomaticSelectedPayment
	 * Checks how many plugins are available. If only one, the user will not have the choice. Enter edit_xxx page
	 * The plugin must check first if it is the correct type
	 * @author Valerie Isaksen
	 * @param VirtueMartCart cart: the cart object
	 * @return null if no plugin was found, 0 if more then one plugin was found,  virtuemart_xxx_id if only one plugin is found
	 *
	 */
	function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array()) {
		return $this->onCheckAutomaticSelected($cart, $cart_prices);
	}
	/**
	 * This method is fired when showing the order details in the frontend.
	 * It displays the method-specific data.
	 *
	 * @param integer $order_id The order ID
	 * @return mixed Null for methods that aren't active, text (HTML) otherwise
	 * @author Max Milbers
	 * @author Valerie Isaksen
	 */
	public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name) {
		$this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
	}
	/**
	 * This method is fired when showing when priting an Order
	 * It displays the the payment method-specific data.
	 *
	 * @param integer $_virtuemart_order_id The order ID
	 * @param integer $method_id  method used for this order
	 * @return mixed Null when for payment methods that were not selected, text (HTML) otherwise
	 * @author Valerie Isaksen
	 */
	function plgVmonShowOrderPrintPayment($order_number, $method_id) {
		return $this->onShowOrderPrint($order_number, $method_id);
	}
	function plgVmDeclarePluginParamsPaymentVM3( &$data) {
		return $this->declarePluginParams('payment', $data);
	}
	function plgVmSetOnTablePluginParamsPayment($name, $id, &$table) {
		return $this->setOnTablePluginParams($name, $id, $table);
	}
  function _getMerchantId($method)
	{
		return $method->vcs_terminal_id;
	}  
	function _getVcsUrl($method)
	{
		return 'www.vcs.co.za/vvonline/vcspay.aspx';	
	}
	function _getVcsUrlHttps($method) 
	{
		return $this->_getVcsUrl($method);
	}
}

// No closing tag
